;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

    FILESIZE equ 20000000

;==============================================================================
    .data
        hFile1 dd 0
        hFile2 dd 0
        hFile3 dd 0
        hMap1  dd 0
        hMap2  dd 0
        hMap3  dd 0
        pMem1  dd 0
        pMem2  dd 0
        pMem3  dd 0
    .code
;==============================================================================
start:
;==============================================================================

    ;-------------------------
    ; Create the sample file.
    ;-------------------------

    mov edi, fcreate("sample.dat")
    mov esi, alloc(FILESIZE)
    xor ebx, ebx
    .WHILE ebx < FILESIZE
        invoke nrandom, 36
        .IF eax > 9
            add al, 'A'-10
        .ELSE
            add al, '0'
        .ENDIF
        mov [esi+ebx], al
        inc ebx
    .ENDW
    mov eax, fwrite(edi,esi,FILESIZE)
    print str$(eax)," bytes",13,10
    fclose edi
    free esi

    invoke GetTickCount
    push eax

    ;----------------------------------
    ; Open/create the necessary files.
    ;----------------------------------

    invoke CreateFile, chr$("sample.dat"),
                       GENERIC_READ or GENERIC_WRITE,
                       FILE_SHARE_READ or FILE_SHARE_WRITE,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL
    mov hFile1, eax
    invoke CreateFile, chr$("letters.dat"),
                       GENERIC_READ or GENERIC_WRITE,
                       FILE_SHARE_READ or FILE_SHARE_WRITE,
                       NULL,
                       CREATE_ALWAYS,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL
    mov hFile2, eax
    invoke CreateFile, chr$("numbers.dat"),
                       GENERIC_READ or GENERIC_WRITE,
                       FILE_SHARE_READ or FILE_SHARE_WRITE,
                       NULL,
                       CREATE_ALWAYS,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL
    mov hFile3, eax

    ;--------------------------------------------------------------
    ; Create an unnamed file mapping object for each of the files.
    ; The maximum size of the first will be the size of the file.
    ; For the second and third the size of the file is zero, so
    ; an appropriate maximum size must be specified.
    ;--------------------------------------------------------------

    invoke CreateFileMapping, hFile1,
                              NULL,
                              PAGE_READWRITE,
                              0,
                              0,
                              NULL
    mov hMap1, eax
    invoke CreateFileMapping, hFile2,
                              NULL,
                              PAGE_READWRITE,
                              0,
                              FILESIZE,
                              NULL
    mov hMap2, eax
    invoke CreateFileMapping, hFile3,
                              NULL,
                              PAGE_READWRITE,
                              0,
                              FILESIZE,
                              NULL
    mov hMap3, eax

    ;---------------------------------------------------------
    ; Map a view of each of the files into our address space.
    ; The return value is the starting address of the mapped
    ; view.
    ;---------------------------------------------------------

    invoke MapViewOfFile, hMap1, FILE_MAP_WRITE, 0, 0, 0
    mov pMem1, eax
    invoke MapViewOfFile, hMap2, FILE_MAP_WRITE, 0, 0, 0
    mov pMem2, eax
    invoke MapViewOfFile, hMap3, FILE_MAP_WRITE, 0, 0, 0
    mov pMem3, eax

    ;------------------------------------------------
    ; Scan the sample a byte at a time and copy each
    ; byte to the appropriate mapped view.
    ;------------------------------------------------

    push ebp
    mov ebx, pMem1
    mov ecx, pMem2
    mov edx, pMem3
    xor ebp, ebp
    xor esi, esi
    xor edi, edi
    .WHILE ebp < FILESIZE
        mov al, [ebx+ebp]
        inc ebp
        .IF al >= 'A' && al <= 'Z'
            mov [ecx+esi], al
            inc esi
        .ELSE
            mov [edx+edi], al
            inc edi
        .ENDIF
    .ENDW
    pop ebp

    ;-----------------------------------------------------------
    ; For SetEndOfFile to work we must first unmap the views of
    ; the files and close the file mapping object handles.
    ;-----------------------------------------------------------

    invoke UnmapViewOfFile, pMem1
    invoke UnmapViewOfFile, pMem2
    invoke UnmapViewOfFile, pMem3

    invoke CloseHandle, hMap1
    invoke CloseHandle, hMap2
    invoke CloseHandle, hMap3

    ;---------------------------------------------------
    ; Truncate the output files at the end of the data.
    ;---------------------------------------------------

    invoke SetFilePointer, hFile2, esi, 0, FILE_BEGIN
    invoke SetFilePointer, hFile3, edi, 0, FILE_BEGIN
    invoke SetEndOfFile, hFile2
    invoke SetEndOfFile, hFile3

    fclose hFile1
    fclose hFile2
    fclose hFile3

    invoke GetTickCount
    pop edx
    sub eax, edx
    print str$(eax)," ms",13,10,13,10

    inkey "Press any key to exit..."
    exit

;==============================================================================
end start
